/* 17.11.2015 trigger pro zpis pohybu vratnch obal */
SET TERM ^ ;

CREATE OR ALTER trigger s022_biud15 for s022
active before insert or update or delete position 15
AS
  declare variable TYP char(1);
  declare variable NAZ varchar(40);
begin
  /* aktualizace saldokonta vratnych obalu */
  /* vymaz puvodniho radku */
  if ((deleting) or (updating)) then begin
    if (((old.TypDP = 'NA') or (old.TypDP = 'PR')) and (old.DruhDp > 0) and (old.DruhDp < 9) and (old.Mnoz <> 0) and (old.BS = 'N')) then begin
      select Typ1 from S010 where Cislo = old.Cislo into TYP;
      if (TYP = '3') then 
        delete from S051
         where Doklad = old.Doklad and Radek = old.Radek;
    end
  end
  /* zapis */
  if ((inserting) or (updating)) then begin
    if (((new.TypDP = 'NA') or (new.TypDP = 'PR')) and (new.DruhDp > 0) and (new.DruhDp < 9) and (new.Mnoz <> 0) and (new.BS = 'N')) then begin
      select Typ1 from S010 where Cislo = new.Cislo into TYP;
      if (TYP = '3') then begin
        select coalesce(NazevDO,' ') from S021 where Doklad = new.Doklad into NAZ;
        insert into S051 (NAZEVDO,CISLO,DOKLAD,RADEK,DATUM,DP,DRUHDP,SKLAD,PRIJAL,VRATIL)
          values (:NAZ,new.Cislo,new.Doklad,new.Radek,new.Datum,new.Dp,
                  case when new.DruhDp = 1 then 1 else 2 end,new.Sklad,
                  case when new.Mnoz > 0 then  new.Mnoz else 0 end,
                  case when new.Mnoz < 0 then -new.Mnoz else 0 end);
      end
    end
  end
end^

SET TERM ; ^


